.386
.model flat,stdcall
option casemap:none

include Main.inc


.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,0
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,OFFSET szMenuName
	mov		wc.lpszClassName,OFFSET szClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	
	invoke CreateDialogParam,hInstance,addr szDlgName,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov	eax,msg.wParam
	ret

WinMain endp
WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL nPos		:DWORD
	LOCAL yAmount	:DWORD
	LOCAL xAmount	:DWORD
	
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push	hwnd
		pop		hWnd
		
		mov siVert.cbSize,sizeof SCROLLINFO
		mov siVert.fMask,SIF_ALL
		mov siVert.nMin,0
		mov siVert.nPos,0
		
		mov siHorz.cbSize,sizeof SCROLLINFO
		mov siHorz.fMask,SIF_ALL
		mov siHorz.nMin,0
		mov siHorz.nPos,0
		
		invoke ShowScrollBar,hwnd,SB_BOTH,TRUE
;---------------------------------------------------		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov edx,eax
		shr edx,16
		.if ax==IDM_FILE_EXIT
			invoke SendMessage,hwnd,WM_CLOSE,0,0
		.elseif ax==IDM_HELP_ABOUT
			invoke ShellAbout,hwnd,addr szAppName,addr szAboutMsg,NULL
		.endif
;---------------------------------------------------		
	.elseif eax==WM_SIZE
		.if hwnd
            mov eax,nVertSteps
            dec eax
            mov siVert.nMax,eax
            HIWORD lParam
            xor edx,edx
            mov ecx,yStep
            div ecx
            mov siVert.nPage,eax
            
            mov eax,nHorzSteps
            dec eax
            mov siHorz.nMax,eax
            LOWORD lParam
            xor edx,edx
            mov ecx,xStep
            div ecx
            mov siHorz.nPage,eax
            
            invoke SetScrollInfo,hwnd,SB_VERT,addr siVert,TRUE
            invoke SetScrollInfo,hwnd,SB_HORZ,addr siHorz,TRUE
          
		.endif  
;---------------------------------------------------		
    .elseif eax==WM_VSCROLL
    	mov eax,wParam
		.if ax==SB_ENDSCROLL
			jmp exit
		.endif
		HIWORD 	wParam
		mov nPos,eax
		mov edx,wParam
		.if dx==SB_LINEDOWN
			mov eax,siVert.nMax
			sub eax,siVert.nPage
			inc eax
			cmp siVert.nPos,eax
			jge exit
			mov eax,yStep
			neg eax
			inc siVert.nPos
			mov yAmount,eax
		.elseif dx==SB_LINEUP
			cmp siVert.nPos,0
			jle exit
			mov eax,yStep
			dec siVert.nPos
			mov yAmount,eax
		.elseif dx==SB_THUMBPOSITION
			mov eax,siVert.nPos
			sub eax,nPos
			imul eax,yStep
			mov yAmount,eax
			mov eax,nPos
			mov siVert.nPos,eax
		.elseif dx==SB_THUMBTRACK
			mov eax,siVert.nPos
			sub eax,nPos
			imul eax,yStep
			mov yAmount,eax
			mov eax,nPos
			mov siVert.nPos,eax
		.elseif dx==SB_PAGEDOWN
			jmp exit
		.elseif dx==SB_PAGEUP
			jmp exit
		.endif
		invoke ScrollWindow,hwnd,0,yAmount,NULL,NULL
		invoke SetScrollInfo,hwnd,SB_VERT,addr siVert,TRUE
		invoke UpdateWindow,hwnd
;---------------------------------------------------		
    .elseif eax==WM_HSCROLL
    
;---------------------------------------------------		
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hwnd
;---------------------------------------------------		
	.elseif uMsg==WM_DESTROY
    	
		invoke PostQuitMessage,NULL
;---------------------------------------------------		
	.else
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ret
	.endif
	exit:
	xor eax,eax
	ret

WndProc endp


end start
